// A little PETSCII intro for the Vammala Party'17 (Jarkko rikkoi omansa)

#include <stdio.h>
#include <string.h>
#include <delta_c.c> // Shouldn't do this, but I did it anyway

#define CHAR_RAM 0xc00
#define COLOR_RAM 0x800
#define waitline(x) while(*(unsigned char *)0xff1d!=(x))

extern char delta[];

extern void biisi_start(void);
extern void biisi_play(void);
extern char biisi[],biisi2[];

char *scroll=
"                                        "
"Fit & Friends present at Vammala Party 2017: Nothing but PET SKI. "
"And as you know, we keep our promises - there is nothing else here "
"than a pet (a jolly cat) skiing downhill. Animation by Dr. TerrorZ, "
"music by Yzi and this pitiful piece of code by Marq. Greetings to "
"Mikron as usual. "
"                 --WRAP--"
"                                        ";

void main()
{
	int frame=0,slen=strlen(scroll),off=0,ys=1,y=1;
	unsigned char c,skrol=7,sidi=0;

	// border: 110, pen: 16, bg: 113

	*(char *)0xff13=0xd0;

	puts("");
	puts("sid card address and return, please:");
	puts("1 - $fd40");
	puts("2 - $fe80");
	printf(">");
	scanf("%c",&c);
	if(c=='2')
		sidi=1;

	memset((char *)COLOR_RAM,110,1000);
	__asm__("sei");
	while(1)
	{
		waitline(0);
		*(char *)0xff15=110;
		waitline(y);
		*(char *)0xff15=113;

		ys++;
		y+=ys;
		if(y>210)
		{
			y-=ys;
			ys=-(ys>>1);

			if(ys==0)
				break;
		}
	}

	*(char *)0xff06=0xb;
	*(char *)0xff13=0xd5;

	// Convert *SCII to screen codes
	printf("%c%s",147,scroll);
	memcpy(scroll,(char *)CHAR_RAM,slen);
	memset((char *)COLOR_RAM,113,1000);

	__asm__("sei");
	*(char *)0xff15=113;
    *(char *)0xff19=113;
	*(char *)0xff13=0xd0;

	// Fade in (rather brutal now)
	memcpy((char *)CHAR_RAM,delta+2,1000);
	memcpy((char *)COLOR_RAM,delta+1002,1000);

	if(sidi)
		memcpy((char *)0xe000,biisi2,4096);
	else
		memcpy((char *)0xe000,biisi,4096);

	*(char *)0xff06=0x1b;

	biisi_start();
	ys=1;
	y=50;

	while(1) // Main loop
	{
		for(c=0;c<3;c++) // Draw one diff of anim
		{
			waitline(192);
			*(char *)0xff13=0xd5;
			*(char *)0xff07=skrol;
//		    *(char *)0xff19=110;

			waitline(220);
			waitline(221);
			biisi_play();
			*(char *)0xff13=0xd0;
			*(char *)0xff07=8;
//		    *(char *)0xff19=113;

			deltafp[frame]();

			memset((char *)COLOR_RAM+40*24,45,40);
			memcpy((char *)CHAR_RAM+40*24,&scroll[off],40);

			skrol--;
			if(skrol==255)
				skrol=7;

			if(skrol==0)
			{
				off++;
				if(off==slen-40)
					off=0;
			}
		}

		frame++;
		if(frame==8)
			frame=0;
	}
}
